"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _default = {
  propValues: {
    scenario: [{
      title: "correct answer before 'uncategorized'",
      correct: true,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            }
          }
        }
      }
    }, {
      title: "incorrect answer before 'uncategorized'",
      correct: false,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: false
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: false
            },
            distractor1: {
              resultScore: 0,
              userResponded: true
            }
          }
        }
      }
    }, {
      title: "incorrect answer before 'uncategorized'",
      correct: false,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: false
            },
            cat2item: {
              resultScore: 0,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: false
            },
            distractor2: {
              resultScore: 0,
              userResponded: true
            }
          }
        }
      }
    }, {
      title: "incorrect answer before 'uncategorized' (only distractors missed)",
      correct: false,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            },
            distractor2: {
              resultScore: 0,
              userResponded: true
            }
          }
        }
      }
    }, {
      title: "correct answer with 'uncategorized'",
      correct: true,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            }
          }
        }
      },
      uncategorized: {
        distractor1: {
          resultScore: 1,
          userResponded: true
        },
        distractor2: {
          resultScore: 1,
          userResponded: true
        }
      }
    }, {
      title: "incorrect answer with 'uncategorized'",
      correct: true,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: false
            },
            distractor2: {
              resultScore: 0,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            }
          }
        }
      },
      uncategorized: {
        cat1item: {
          resultScore: 0,
          userResponded: true
        },
        distractor1: {
          resultScore: 1,
          userResponded: true
        },
        distractor2: {
          resultScore: 1,
          userResponded: false
        }
      }
    }, {
      title: "incorrect answer with 'uncategorized' (only distractors missed)",
      correct: false,
      value: {
        cat1: {
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            }
          }
        },
        cat2: {
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            },
            distractor1: {
              resultScore: 0,
              userResponded: true
            }
          }
        }
      },
      uncategorized: {
        distractor1: {
          resultScore: 1,
          userResponded: false
        },
        distractor2: {
          resultScore: 1,
          userResponded: true
        }
      }
    }, {
      title: "correctness only with 'uncategorized'",
      correct: false,
      value: {
        cat1: {
          value: {
            cat1item: {
              userResponded: true,
              resultScore: 1
            }
          }
        },
        cat2: {
          value: {
            distractor2: {
              userResponded: true,
              resultScore: 0
            }
          }
        }
      },
      uncategorized: {
        cat2item: {
          userResponded: true,
          resultScore: 0
        },
        distractor1: {
          userResponded: true,
          resultScore: 1
        }
      }
    }, {
      title: "correctness only without 'uncategorized' (incorrect)",
      correct: false,
      value: {
        cat1: {
          correct: false,
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            },
            cat2item: {
              resultScore: 0,
              userResponded: true
            },
            distractor1: {
              resultScore: 0,
              userResponded: true
            }
          }
        },
        cat2: {
          correct: false,
          value: {}
        }
      }
    }, {
      title: "correctness only without 'uncategorized' (correct)",
      correct: true,
      value: {
        cat1: {
          correct: true,
          value: {
            cat1item: {
              resultScore: 1,
              userResponded: true
            }
          }
        },
        cat2: {
          correct: true,
          value: {
            cat2item: {
              resultScore: 1,
              userResponded: true
            }
          }
        }
      }
    }, {
      title: 'user response only',
      value: {
        cat1: {
          value: {
            cat1item: {
              userResponded: true
            },
            cat2item: {
              userResponded: false
            },
            distractor1: {
              userResponded: false
            },
            distractor2: {
              userResponded: false
            }
          }
        },
        cat2: {
          value: {
            cat1item: {
              userResponded: false
            },
            cat2item: {
              userResponded: false
            },
            distractor1: {
              userResponded: true
            },
            distractor2: {
              userResponded: true
            }
          }
        }
      }
    }, {
      title: 'no user data',
      value: {
        cat1: {},
        cat2: {}
      }
    }, {
      title: 'null',
      value: null
    }]
  },
  getComponentProps: function getComponentProps(props) {
    var _props$scenario = props.scenario,
        title = _props$scenario.title,
        scoredData = (0, _objectWithoutProperties2.default)(_props$scenario, ["title"]);
    return {
      itemBody: "Categorization: ".concat(title),
      interactionData: {
        categoryOrder: ['cat1', 'cat2'],
        categories: {
          cat1: {
            id: 'cat1',
            itemBody: 'Planet'
          },
          cat2: {
            id: 'cat2',
            itemBody: 'Moon'
          }
        },
        distractors: {
          cat1item: {
            id: 'cat1item',
            itemBody: 'Mars'
          },
          cat2item: {
            id: 'cat2item',
            itemBody: 'Europa'
          },
          distractor1: {
            id: 'distractor1',
            itemBody: 'Asia'
          },
          distractor2: {
            id: 'distractor2',
            itemBody: 'America'
          }
        }
      },
      scoredData: scoredData
    };
  }
};
exports.default = _default;