"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Card = exports.cardTarget = exports.cardSource = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDnd = require("react-dnd");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var style = {
  cursor: 'move',
  // needs relative position to keep absolutely positioned content
  // (such as ScreenReaderContent) from blowing up the drag preview
  position: 'relative'
};
var cardSource = {
  beginDrag: function beginDrag(props) {
    return {
      id: props.id,
      index: props.index
    };
  },
  endDrag: function endDrag(props, monitor) {
    var item = monitor.getItem();
    var dropResult = monitor.getDropResult();

    if (!dropResult && props.onDropOut) {
      props.onDropOut(item);
    }
  },
  isDragging: function isDragging(props, monitor) {
    return props.id === monitor.getItem().id;
  }
};
exports.cardSource = cardSource;
var cardTarget = {
  hover: function hover(props, monitor) {
    var item = monitor.getItem();
    var dragIndex = item.index;
    var hoverIndex = props.index; // Don't replace items with themselves and with items without index

    if (dragIndex === void 0 || dragIndex === hoverIndex) {
      return;
    } // Don't move item if given an allowed target group,
    // and the drop target is not the allowed group


    if (props.choices && !props.choices.hasOwnProperty(item.id)) {
      return;
    }

    props.moveCard(dragIndex, hoverIndex); // Note: we're mutating the monitor item here!
    // Generally it's better to avoid mutations,
    // but it's good here for the sake of performance
    // to avoid expensive index searches.

    monitor.getItem().index = hoverIndex; // eslint-disable-line no-param-reassign
  }
};
exports.cardTarget = cardTarget;

var Card =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Card, _Component);

  function Card() {
    (0, _classCallCheck2.default)(this, Card);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Card).apply(this, arguments));
  }

  (0, _createClass2.default)(Card, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isDragging = _this$props.isDragging,
          connectDragSource = _this$props.connectDragSource,
          connectDropTarget = _this$props.connectDropTarget,
          margin = _this$props.margin;
      var opacity = isDragging ? 0 : 1;
      return connectDragSource(connectDropTarget(_react.default.createElement("div", {
        style: _objectSpread({}, style, {
          opacity: opacity,
          margin: margin
        })
      }, this.props.children)));
    }
  }]);
  Card.displayName = "Card";
  return Card;
}(_react.Component);

exports.Card = Card;
Card.propTypes = {
  connectDragSource: _propTypes.default.func.isRequired,
  connectDropTarget: _propTypes.default.func.isRequired,
  index: _propTypes.default.number,
  isDragging: _propTypes.default.bool.isRequired,
  id: _propTypes.default.any.isRequired,
  choices: _propTypes.default.object,
  moveCard: _propTypes.default.func,
  children: _propTypes.default.node,
  margin: _propTypes.default.string
};
Card.defaultProps = {
  index: void 0,
  choices: void 0,
  moveCard: void 0,
  children: void 0,
  margin: '0'
};
var SourceCard = (0, _reactDnd.DragSource)('dnd', cardSource, function (connect, monitor) {
  return {
    connectDragSource: connect.dragSource(),
    isDragging: monitor.isDragging()
  };
})(Card);
var TargetAndSourceCard = (0, _reactDnd.DropTarget)('dnd', cardTarget, function (connect) {
  return {
    connectDropTarget: connect.dropTarget()
  };
})(SourceCard);
var _default = TargetAndSourceCard;
exports.default = _default;