"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _striptags = _interopRequireDefault(require("striptags"));

var _uiIcons = require("@instructure/ui-icons");

var _uiButtons = require("@instructure/ui-buttons");

var _uiA11y = require("@instructure/ui-a11y");

var _uiLayout = require("@instructure/ui-layout");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var EditAnswerFeedbackButton =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EditAnswerFeedbackButton, _Component);

  function EditAnswerFeedbackButton() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, EditAnswerFeedbackButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(EditAnswerFeedbackButton)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.button = null;

    _this.focus = function () {
      _this.button.focus();
    };

    _this.generateText = function () {
      if (_this.props.iconFilled) {
        return (0, _formatMessage.default)('Edit Answer Feedback: {choice}, feedback present', {
          choice: (0, _striptags.default)(_this.props.itemBody)
        });
      } else {
        return (0, _formatMessage.default)('Edit Answer Feedback: {choice}, no feedback present', {
          choice: (0, _striptags.default)(_this.props.itemBody)
        });
      }
    };

    _this.handleRef = function (node) {
      _this.button = node;
    };

    _this.handleClick = function (event) {
      _this.props.onEditChoiceFeedback(_this.props.choiceId);

      var expanded = _this.props.expanded ? (0, _formatMessage.default)('Answer feedback editor closed') : (0, _formatMessage.default)('Answer feedback editor opened');

      _this.props.notifyScreenreader(expanded);
    };

    return _this;
  }

  (0, _createClass2.default)(EditAnswerFeedbackButton, [{
    key: "render",
    // ===========
    //   RENDERS
    // ===========
    value: function render() {
      var text = this.generateText();
      return _react.default.createElement(_uiLayout.Flex, {
        padding: "xx-small 0 0",
        justifyItems: "center",
        alignItems: "start"
      }, _react.default.createElement(_uiLayout.Flex.Item, null, _react.default.createElement(_uiButtons.Button, {
        variant: "icon",
        name: this.props.choiceId,
        onClick: this.handleClick,
        ref: this.handleRef,
        size: "medium",
        icon: this.props.iconFilled ? _uiIcons.IconCommentSolid : _uiIcons.IconCommentLine,
        label: text
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, text))));
    }
  }]);
  EditAnswerFeedbackButton.displayName = "EditAnswerFeedbackButton";
  return EditAnswerFeedbackButton;
}(_react.Component);

exports.default = EditAnswerFeedbackButton;
EditAnswerFeedbackButton.propTypes = {
  choiceId: _propTypes.default.string.isRequired,
  iconFilled: _propTypes.default.bool,
  onEditChoiceFeedback: _propTypes.default.func,
  itemBody: _propTypes.default.string.isRequired,
  notifyScreenreader: _propTypes.default.func.isRequired,
  expanded: _propTypes.default.bool.isRequired
};
EditAnswerFeedbackButton.defaultProps = {
  onEditChoiceFeedback: function onEditChoiceFeedback() {},
  iconFilled: false
};