"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactRequiredIf = _interopRequireDefault(require("react-required-if"));

var _uuid = require("uuid");

var _uiThemeable = require("@instructure/ui-themeable");

var _uiA11y = require("@instructure/ui-a11y");

var _quizRce = require("@instructure/quiz-rce");

var _instUIMessages = require("../../../../../util/instUIMessages");

var _PlainTextInput = _interopRequireDefault(require("../PlainTextInput"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'dAhrK',
  template: function template(theme) {
    return "\n\n.dAhrK_cSuF{background-color:".concat(theme.questionBackgroundColor || 'inherit', ";box-sizing:border-box;color:").concat(theme.questionColor || 'inherit', ";width:100%}\n\n.dAhrK_cSuF fieldset{border:none}\n\n.dAhrK_cloC{flex:11 11 auto;margin-bottom:").concat(theme.stemMargin || 'inherit', "}");
  },
  'question': 'dAhrK_cSuF',
  'stem': 'dAhrK_cloC'
};
var QuestionContainer = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(QuestionContainer, _Component);

  function QuestionContainer() {
    var _this;

    (0, _classCallCheck2.default)(this, QuestionContainer);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(QuestionContainer).apply(this, arguments));

    _this.handleRichContentChange = function (event, rceContent) {
      var editorContent = rceContent.editorContent;

      if (editorContent === void 0) {
        return;
      }

      _this.updateDescription(editorContent);
    };

    _this.handlePlainTextChange = function (event, content) {
      _this.updateDescription(content);
    };

    _this.handleRef = function (node) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      _this.props.textareaRef.apply((0, _assertThisInitialized2.default)(_this), [node].concat(args));
    };

    _this._defaultId = "QuestionContainer_".concat((0, _uuid.v4)());
    _this.state = {
      editorContent: _this.props.itemBody
    };
    return _this;
  }

  (0, _createClass2.default)(QuestionContainer, [{
    key: "updateDescription",
    value: function updateDescription(editorContent) {
      // check if the content actually changed before calling onDescriptionChange
      if (this.state.editorContent !== editorContent) {
        this.setState({
          editorContent: editorContent
        });
        this.props.onDescriptionChange(editorContent);
      }
    }
  }, {
    key: "renderRichContentInput",
    value: function renderRichContentInput() {
      return _react.default.createElement(_quizRce.RichContentInput, {
        actsAsInput: true,
        defaultContent: this.props.itemBody,
        disabled: this.props.disabled,
        focusOnMount: this.props.focusOnMount,
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Question Stem')),
        messages: (0, _instUIMessages.toErrors)(this.props.stemErrors),
        onChange: this.handleRichContentChange,
        onKeyUp: this.handleRichContentChange,
        onModalClose: this.props.onModalClose,
        onModalOpen: this.props.onModalOpen,
        openImportModal: this.props.openImportModal,
        placeholder: this.props.placeholder || (0, _formatMessage.default)('Add Question Stem...'),
        readOnly: this.props.readOnly,
        ref: this.handleRef,
        renderImportModal: this.props.renderImportModal,
        textareaId: this.id
      });
    }
  }, {
    key: "renderPlainTextInput",
    value: function renderPlainTextInput() {
      return _react.default.createElement(_PlainTextInput.default, {
        defaultValue: this.props.itemBody,
        disabled: this.props.disabled,
        focusOnMount: this.props.focusOnMount,
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Question Stem')),
        messages: (0, _instUIMessages.toErrors)(this.props.stemErrors),
        onChange: this.handlePlainTextChange,
        placeholder: this.props.placeholder || (0, _formatMessage.default)('Add Question Stem...'),
        textareaRef: this.handleRef
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.question
      }, _react.default.createElement("div", {
        className: styles.stem,
        "data-automation": "sdk-question-stem"
      }, this.props.enableRichContentEditor ? this.renderRichContentInput() : this.renderPlainTextInput()), this.props.children);
    }
  }, {
    key: "id",
    get: function get() {
      return this.props.textareaId || this._defaultId;
    }
  }]);
  QuestionContainer.displayName = "QuestionContainer";
  return QuestionContainer;
}(_react.Component), _class2.propTypes = {
  children: _propTypes.default.oneOfType([_propTypes.default.object.isRequired, _propTypes.default.array.isRequired]),
  disabled: _propTypes.default.bool,
  enableRichContentEditor: _propTypes.default.bool,
  focusOnMount: _propTypes.default.bool,
  itemBody: _propTypes.default.string,
  onDescriptionChange: _propTypes.default.func.isRequired,
  onModalClose: _propTypes.default.func,
  onModalOpen: _propTypes.default.func,
  openImportModal: (0, _reactRequiredIf.default)(_propTypes.default.func, function (props) {
    return props.enableRichContentEditor;
  }),
  placeholder: _propTypes.default.string,
  readOnly: _propTypes.default.bool,
  renderImportModal: (0, _reactRequiredIf.default)(_propTypes.default.func, function (props) {
    return props.enableRichContentEditor;
  }),
  stemErrors: _propTypes.default.array,
  textareaId: _propTypes.default.string,
  textareaRef: _propTypes.default.func
}, _class2.defaultProps = {
  disabled: false,
  enableRichContentEditor: true,
  focusOnMount: false,
  itemBody: '',
  placeholder: null,
  readOnly: false,
  textareaRef: Function.prototype,
  children: void 0,
  onModalClose: void 0,
  onModalOpen: void 0,
  openImportModal: void 0,
  renderImportModal: void 0,
  stemErrors: void 0,
  textareaId: void 0
}, _temp)) || _class);
exports.default = QuestionContainer;