"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiForms = require("@instructure/ui-forms");

var _uiA11y = require("@instructure/ui-a11y");

var _uiElements = require("@instructure/ui-elements");

var _uiThemeable = require("@instructure/ui-themeable");

var _BlankChoices = _interopRequireDefault(require("./blank_type_options/BlankChoices"));

var _OpenEntry = _interopRequireDefault(require("./components/OpenEntry"));

var _theme = _interopRequireDefault(require("./theme"));

var _defaultOpenEntry = require("./blank_type_options/defaultOpenEntry");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'bmZci',
  template: function template(theme) {
    return "\n\n.bmZci_esyG{align-items:center;display:flex;margin:".concat(theme.blankTextMargin || 'inherit', " 0}\n\n.bmZci_bBjh{display:flex;flex-direction:column}\n\n.bmZci_drjL{border:").concat(theme.numCircleBorderWidth || 'inherit', " solid ").concat(theme.numCircleBorderColor || 'inherit', ";border-radius:0.8em;color:").concat(theme.numCircleColor || 'inherit', ";display:inline-block;line-height:1.6em;margin-right:").concat(theme.numCircleMargin || 'inherit', ";text-align:center;width:1.6em}\n\n[dir=ltr] .bmZci_drjL,[dir=rtl] .bmZci_drjL{text-align:center}\n\n.bmZci_cJcq{flex:1;padding-right:").concat(theme.selectWrapperPadding || 'inherit', "}\n\n.bmZci_fzje{flex:2}\n\n.bmZci_eSFF{display:flex;margin-bottom:").concat(theme.optionsWrapperMargin || 'inherit', "}");
  },
  'blankText': 'bmZci_esyG',
  'mainWrapper': 'bmZci_bBjh',
  'numCircle': 'bmZci_drjL',
  'selectWrapper': 'bmZci_cJcq',
  'answerTypeWrapper': 'bmZci_fzje',
  'optionsWrapper': 'bmZci_eSFF'
};
var BlankTypeSelect = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(BlankTypeSelect, _Component);

  function BlankTypeSelect() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, BlankTypeSelect);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(BlankTypeSelect)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.select = null;

    _this.updateBlankAnswerType = function (e, _ref) {
      var answerType = _ref.value;

      // from choice to choice type, do nothing but update blank
      // if openEntry to choice, create default choice and update scoringAlgorithm
      // if choice to openEntry, update scoringData, algorithm
      if (answerType === 'openEntry' && _this.props.answerType !== 'openEntry') {
        _this.__updateToNewOpenEntryType('TextContainsAnswer'); // Setting choices to null removes the choices from the blank


        _this.props.updateBlank({
          choices: null,
          answerType: answerType
        });
      } else if (answerType !== 'openEntry' && _this.props.answerType === 'openEntry') {
        _this.__updateToNewChoicesType(answerType);
      } else {
        _this.props.updateBlank({
          answerType: answerType
        });
      }
    };

    _this.updateBlankTextMatch = function (e, _ref2) {
      var value = _ref2.value;

      _this.__updateToNewOpenEntryType(value);
    };

    _this.handleSelectRef = function (node) {
      _this.select = node;
    };

    return _this;
  }

  (0, _createClass2.default)(BlankTypeSelect, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.focusOnMount) {
        this.select.focus();
      }
    } // ===========
    //   ACTIONS
    // ===========

  }, {
    key: "__updateToNewOpenEntryType",
    value: function __updateToNewOpenEntryType(scoringAlgorithm) {
      var blankText = this.props.blankScoringData.blankText;
      var scoringData;

      switch (scoringAlgorithm) {
        case 'TextRegex':
        case 'TextContainsAnswer':
        case 'TextEquivalence':
        case 'Equivalence':
          this.props.updateBlankScoringData({
            scoringData: {
              value: blankText,
              blankText: blankText
            },
            scoringAlgorithm: scoringAlgorithm
          });
          break;

        case 'TextCloseEnough':
          scoringData = (0, _defaultOpenEntry.setupDefaultEditDistance)(blankText);
          this.props.updateBlankScoringData({
            scoringData: scoringData,
            scoringAlgorithm: scoringAlgorithm
          });
          break;

        case 'TextInChoices':
          scoringData = (0, _defaultOpenEntry.setupDefaultSpecifiedAnswers)(blankText);
          this.props.updateBlankScoringData({
            scoringData: scoringData,
            scoringAlgorithm: scoringAlgorithm
          });
          break;
      }
    }
  }, {
    key: "__updateToNewChoicesType",
    value: function __updateToNewChoicesType(answerType) {
      var mods = (0, _defaultOpenEntry.setupDefaultChoices)(this.props.blankScoringData.blankText);
      this.props.updateBlankScoringData({
        scoringData: mods.scoringData,
        scoringAlgorithm: 'Equivalence'
      });
      this.props.updateBlank({
        choices: mods.choices,
        answerType: answerType
      });
    }
  }, {
    key: "renderChoicesType",
    // =============
    //   RENDERING
    // =============
    value: function renderChoicesType() {
      var choices = this.props.choices;
      var sortedChoices = choices.slice().sort(function (a, b) {
        return a.position - b.position;
      });
      return _react.default.createElement(_BlankChoices.default, {
        blankName: this.props.name,
        choices: sortedChoices,
        disabled: this.props.disabled,
        errors: this.props.choicesErrors,
        interactionDataErrors: this.props.interactionDataErrors,
        notifyScreenreader: this.props.notifyScreenreader,
        onModalClose: this.props.onModalClose,
        onModalOpen: this.props.onModalOpen,
        scoringDataErrors: this.props.scoringDataErrors,
        scoringDataForBlank: this.props.blankScoringData,
        updateBlank: this.props.updateBlank,
        updateScoringDataForBlank: this.props.updateBlankScoringData
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          answerType = _this$props.answerType,
          blankScoringData = _this$props.blankScoringData;
      var renderChoices = answerType === 'dropdown' || answerType === 'wordbank';
      return _react.default.createElement("div", {
        className: styles.mainWrapper
      }, _react.default.createElement("div", {
        className: styles.blankText
      }, _react.default.createElement("span", {
        className: styles.numCircle,
        "aria-hidden": "true",
        role: "presentation"
      }, this.props.blankPosition), _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Blank {blankNumber, number}', {
        blankNumber: this.props.blankPosition
      })), _react.default.createElement(_uiElements.Text, {
        weight: "bold"
      }, blankScoringData.blankText)), _react.default.createElement("div", {
        className: styles.optionsWrapper
      }, _react.default.createElement("div", {
        className: styles.selectWrapper
      }, _react.default.createElement(_uiForms.Select, {
        ref: this.handleSelectRef,
        disabled: this.props.disabled,
        label: _react.default.createElement("span", null, (0, _formatMessage.default)('Answer Type')),
        onChange: this.updateBlankAnswerType,
        defaultOption: answerType
      }, _react.default.createElement("option", {
        value: "openEntry"
      }, (0, _formatMessage.default)('Open Entry')), _react.default.createElement("option", {
        value: "dropdown"
      }, (0, _formatMessage.default)('Dropdown')), _react.default.createElement("option", {
        value: "wordbank"
      }, (0, _formatMessage.default)('Word Bank')))), _react.default.createElement("div", {
        className: styles.answerTypeWrapper
      }, renderChoices ? this.renderChoicesType() : _react.default.createElement(_OpenEntry.default, {
        blankScoringAlgorithm: this.props.blankScoringAlgorithm,
        blankScoringData: this.props.blankScoringData,
        disabled: this.props.disabled,
        name: this.props.name,
        notifyScreenreader: this.props.notifyScreenreader,
        scoringDataErrors: this.props.scoringDataErrors,
        validationErrorsFromApi: this.props.validationErrorsFromApi,
        updateBlankScoringData: this.props.updateBlankScoringData,
        updateBlankTextMatch: this.updateBlankTextMatch
      }))));
    }
  }]);
  BlankTypeSelect.displayName = "BlankTypeSelect";
  return BlankTypeSelect;
}(_react.Component), _class2.propTypes = {
  answerType: _propTypes.default.string.isRequired,
  blankPosition: _propTypes.default.number,
  blankScoringAlgorithm: _propTypes.default.string.isRequired,
  blankScoringData: _propTypes.default.object.isRequired,
  choices: _propTypes.default.array,
  choicesErrors: _propTypes.default.array,
  disabled: _propTypes.default.bool,
  interactionDataErrors: _propTypes.default.object,
  name: _propTypes.default.string,
  notifyScreenreader: _propTypes.default.func.isRequired,
  onModalClose: _propTypes.default.func,
  onModalOpen: _propTypes.default.func,
  scoringDataErrors: _propTypes.default.object,
  updateBlank: _propTypes.default.func.isRequired,
  updateBlankScoringData: _propTypes.default.func.isRequired,
  focusOnMount: _propTypes.default.bool,
  validationErrorsFromApi: _propTypes.default.array
}, _class2.defaultProps = {
  blankPosition: void 0,
  blankScoringAlgorithm: '',
  blankScoringData: {},
  choices: [],
  choicesErrors: void 0,
  disabled: false,
  interactionDataErrors: void 0,
  name: void 0,
  onModalClose: void 0,
  onModalOpen: void 0,
  scoringDataErrors: void 0,
  focusOnMount: void 0,
  validationErrorsFromApi: []
}, _temp)) || _class);
exports.default = BlankTypeSelect;