"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiThemeable = require("@instructure/ui-themeable");

var _uiForms = require("@instructure/ui-forms");

var _quizNumberInput = _interopRequireDefault(require("@instructure/quiz-number-input"));

var _instUIMessages = require("../../../../../../util/instUIMessages");

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'coQIC',
  template: function template(theme) {
    return "\n\n.coQIC_dBbH{margin:".concat(theme.optionsInputMargin || 'inherit', " 0;width:100%}\n\n.coQIC_dBbH>input{border-radius:").concat(theme.optionsInputBorderRadius || 'inherit', ";box-sizing:border-box;font-size:").concat(theme.optionsInputFontSize || 'inherit', ";font-weight:").concat(theme.optionsInputFontWeight || 'inherit', ";margin-top:").concat(theme.optionsInputConditionalMargin || 'inherit', ";padding:").concat(theme.optionsInputPadding || 'inherit', ";padding-right:0;width:100%}\n\n.coQIC_dBbH:focus>input{background-color:").concat(theme.optionsInputFocusBackColor || 'inherit', ";color:").concat(theme.optionInputFocusColor || 'inherit', "}\n\n.coQIC_ctlp{display:block;margin:").concat(theme.optionsInputCheckbox || 'inherit', " 0}");
  },
  'optionsInput': 'coQIC_dBbH',
  'optionsInputCheckbox': 'coQIC_ctlp'
};
var EditDistance = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EditDistance, _Component);

  function EditDistance() {
    var _this;

    (0, _classCallCheck2.default)(this, EditDistance);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EditDistance).apply(this, arguments));

    _this.handleIgnoreCaseChecked = function () {
      _this.updateScoringData({
        ignoreCase: !_this.props.scoringDataForBlank.ignoreCase
      });
    };

    _this.handleDistanceChange = function (event, value, normalizedValue) {
      _this.setState({
        editDistance: value,
        normalizedEditDistance: normalizedValue
      });
    };

    _this.handleDistanceBlur = function () {
      var distance = parseInt(_this.state.normalizedEditDistance, 10);

      if (!distance && distance !== 0) {
        distance = 0;
      }

      _this.updateScoringData({
        editDistance: distance
      });

      _this.setState({
        editDistance: distance ? "".concat(distance) : '0'
      });
    };

    var editDistance = _this.props.scoringDataForBlank.editDistance;
    _this.state = {
      editDistance: editDistance,
      normalizedEditDistance: editDistance
    };
    return _this;
  }

  (0, _createClass2.default)(EditDistance, [{
    key: "updateScoringData",
    value: function updateScoringData(mods) {
      this.props.updateScoringDataForBlank({
        scoringData: Object.assign({}, this.props.scoringDataForBlank, mods)
      });
    }
  }, {
    key: "render",
    // ===========
    //  RENDER
    // ===========
    value: function render() {
      return _react.default.createElement("div", {
        className: styles.optionsInput
      }, _react.default.createElement(_quizNumberInput.default, {
        min: "0",
        step: "1",
        messages: (0, _instUIMessages.toErrors)(this.props.errors),
        value: this.state.editDistance,
        label: (0, _formatMessage.default)('Levenshtein Distance:'),
        placeholder: (0, _formatMessage.default)('Levenshtein Distance'),
        onChange: this.handleDistanceChange,
        onBlur: this.handleDistanceBlur
      }), _react.default.createElement("div", {
        className: styles.optionsInputCheckbox
      }, _react.default.createElement(_uiForms.Checkbox, {
        value: "ignoreCase",
        label: (0, _formatMessage.default)('Spelling Only (Ignore Case)'),
        checked: this.props.scoringDataForBlank.ignoreCase || false,
        onChange: this.handleIgnoreCaseChecked
      })));
    }
  }]);
  EditDistance.displayName = "EditDistance";
  return EditDistance;
}(_react.Component), _class2.propTypes = {
  errors: _propTypes.default.array,
  scoringDataForBlank: _propTypes.default.shape({
    ignoreCase: _propTypes.default.bool,
    editDistance: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number])
  }),
  updateScoringDataForBlank: _propTypes.default.func
}, _class2.defaultProps = {
  errors: void 0,
  scoringDataForBlank: {},
  updateScoringDataForBlank: void 0
}, _temp)) || _class);
exports.default = EditDistance;