"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _immutabilityHelper = _interopRequireDefault(require("immutability-helper"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _isArray = _interopRequireDefault(require("lodash/isArray"));

var _uiThemeable = require("@instructure/ui-themeable");

var _uiA11y = require("@instructure/ui-a11y");

var _uiForms = require("@instructure/ui-forms");

var _Errors = _interopRequireDefault(require("../../../../../common/edit/components/Errors"));

var _RemoveChoiceButton = _interopRequireDefault(require("../../../../../common/edit/components/RemoveChoiceButton"));

var _Footer = _interopRequireDefault(require("../../../../../common/edit/components/Footer"));

var _instUIMessages = require("../../../../../../util/instUIMessages");

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'cAtJU',
  template: function template(theme) {
    return "\n\n.cAtJU_deIr{display:flex;flex:1}\n\n.cAtJU_dBbH{margin:".concat(theme.optionsInputMargin || 'inherit', " 0;width:100%}\n\n.cAtJU_dBbH>input{border-radius:").concat(theme.optionsInputBorderRadius || 'inherit', ";box-sizing:border-box;font-size:").concat(theme.optionsInputFontSize || 'inherit', ";font-weight:").concat(theme.optionsInputFontWeight || 'inherit', ";margin-top:").concat(theme.optionsInputConditionalMargin || 'inherit', ";padding:").concat(theme.optionsInputPadding || 'inherit', ";padding-right:0;width:100%}\n\n.cAtJU_dBbH:focus>input{background-color:").concat(theme.optionsInputBackgroundColor || 'inherit', ";color:").concat(theme.optionsInputColor || 'inherit', "}");
  },
  'answerOptionWrapper': 'cAtJU_deIr',
  'optionsInput': 'cAtJU_dBbH'
};
var SpecifiedAnswers = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(SpecifiedAnswers, _Component);

  function SpecifiedAnswers() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, SpecifiedAnswers);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(SpecifiedAnswers)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this._timeouts = [];

    _this.updateSpecifiedAnswer = function (index, e) {
      var newSDVal = (0, _immutabilityHelper.default)(_this.__safeScoringDataValue(), (0, _defineProperty2.default)({}, index, {
        $set: e.target.value
      }));

      _this.__updateScoringData(newSDVal);
    };

    _this.setInputRef = function (index) {
      return function (node) {
        _this["input_".concat(index)] = node;
      };
    };

    _this.setRemoveRef = function (index) {
      return function (node) {
        _this["remove_".concat(index)] = node;
      };
    };

    _this.addSpecifiedAnswer = function () {
      _this.__updateScoringData(_this.__safeScoringDataValue().concat(''));

      _this.props.notifyScreenreader((0, _formatMessage.default)('Added specified answer.'));

      _this._timeouts = [].concat((0, _toConsumableArray2.default)(_this._timeouts), [setTimeout(function () {
        var lastInputIndex = _this.__safeScoringDataValue().length - 1;

        _this["input_".concat(lastInputIndex)].focus();
      })]);
    };

    _this.removeSpecifiedAnswer = function (index, e) {
      var newSDVal = (0, _immutabilityHelper.default)(_this.__safeScoringDataValue(), {
        $splice: [[index, 1]]
      });

      _this.__updateScoringData(newSDVal);

      _this.props.notifyScreenreader((0, _formatMessage.default)('Removed specified answer.'));

      _this._timeouts = [].concat((0, _toConsumableArray2.default)(_this._timeouts), [setTimeout(function () {
        var valLength = _this.__safeScoringDataValue().length;

        if (valLength === 1) {
          _this["input_".concat(0)].focus();
        } else if (valLength === index) {
          _this["remove_".concat(index - 1)].focus();
        } else {
          _this["remove_".concat(index)].focus();
        }
      })]);
    };

    return _this;
  }

  (0, _createClass2.default)(SpecifiedAnswers, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._timeouts.forEach(clearTimeout);
    }
  }, {
    key: "__safeScoringDataValue",
    value: function __safeScoringDataValue() {
      return (0, _isArray.default)(this.props.scoringDataForBlank.value) ? this.props.scoringDataForBlank.value : [];
    }
  }, {
    key: "__updateScoringData",
    value: function __updateScoringData(value) {
      this.props.updateScoringDataForBlank({
        scoringData: {
          value: value,
          blankText: value[0]
        }
      });
    }
  }, {
    key: "renderRemoveAnswerButton",
    // === Rendering ===
    value: function renderRemoveAnswerButton(index, onlyAnswer, answer) {
      if (!onlyAnswer) {
        return _react.default.createElement(_RemoveChoiceButton.default, {
          ref: this.setRemoveRef(index),
          choiceId: index,
          screenReaderText: (0, _formatMessage.default)('Remove Answer: {answer}', {
            answer: answer
          }),
          onRemoveChoice: this.removeSpecifiedAnswer
        });
      }
    }
  }, {
    key: "renderAnswer",
    value: function renderAnswer(answer, index, onlyAnswer) {
      return _react.default.createElement("div", {
        className: styles.answerOptionWrapper,
        key: index
      }, _react.default.createElement("div", {
        className: styles.optionsInput
      }, _react.default.createElement(_uiForms.TextInput, {
        messages: (0, _instUIMessages.toErrors)(this.props.errors[index] || []),
        value: answer,
        inputRef: this.setInputRef(index),
        placeholder: (0, _formatMessage.default)('additional correct answer...'),
        label: _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Possible correct answer')),
        onChange: (0, _partial.default)(this.updateSpecifiedAnswer, index)
      })), this.renderRemoveAnswerButton(index, onlyAnswer, answer));
    }
  }, {
    key: "renderSpecifiedAnswers",
    value: function renderSpecifiedAnswers() {
      var _this2 = this;

      var specifiedAnswers = this.__safeScoringDataValue();

      var onlyAnswer = specifiedAnswers.length === 1;
      return specifiedAnswers.map(function (answer, index) {
        return _this2.renderAnswer(answer, index, onlyAnswer);
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_Errors.default, {
        errorList: this.props.errors.$errors || []
      }, _react.default.createElement("div", null, this.renderSpecifiedAnswers(), _react.default.createElement(_Footer.default, {
        onCreateChoice: this.addSpecifiedAnswer
      })));
    }
  }]);
  SpecifiedAnswers.displayName = "SpecifiedAnswers";
  return SpecifiedAnswers;
}(_react.Component), _class2.propTypes = {
  errors: _propTypes.default.object.isRequired,
  notifyScreenreader: _propTypes.default.func.isRequired,
  scoringDataForBlank: _propTypes.default.object.isRequired,
  updateScoringDataForBlank: _propTypes.default.func.isRequired
}, _temp)) || _class);
exports.default = SpecifiedAnswers;