"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiThemeable = require("@instructure/ui-themeable");

var _uiButtons = require("@instructure/ui-buttons");

var _uiIcons = require("@instructure/ui-icons");

var _uiA11y = require("@instructure/ui-a11y");

var _quizCommon = require("@instructure/quiz-common");

var _uiForms = require("@instructure/ui-forms");

var _SpecifiedAnswers = _interopRequireDefault(require("../../blank_type_options/SpecifiedAnswers"));

var _RegexComponent = _interopRequireDefault(require("../../blank_type_options/RegexComponent"));

var _EditDistance = _interopRequireDefault(require("../../blank_type_options/EditDistance"));

var _TipInfo = _interopRequireDefault(require("../TipInfo"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'eDvGz',
  template: function template(theme) {
    return "\n\n.eDvGz_hLXz{float:right;margin:0;padding:0}\n\n[dir=ltr] .eDvGz_hLXz,[dir=rtl] .eDvGz_hLXz{float:right}";
  },
  'questionIcon': 'eDvGz_hLXz'
};

var _ref =
/*#__PURE__*/
_react.default.createElement(_TipInfo.default, null);

var OpenEntry = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(OpenEntry, _Component);

  function OpenEntry() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, OpenEntry);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(OpenEntry)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      isModalOpen: false
    };
    _this.containerRef = null;
    _this.triggerRef = null;

    _this.handleContainerRef = function (el) {
      _this.containerRef = el;
    };

    _this.handleTriggerRef = function (el) {
      _this.triggerRef = el;
    };

    _this.handleCloseModal = function () {
      _this.setState({
        isModalOpen: false
      });
    };

    _this.handleOpenModal = function () {
      _this.setState({
        isModalOpen: true
      });
    };

    return _this;
  }

  (0, _createClass2.default)(OpenEntry, [{
    key: "renderTextMatch",
    value: function renderTextMatch(TextMatchComponent) {
      return _react.default.createElement(TextMatchComponent, {
        validationErrorsFromApi: this.props.validationErrorsFromApi,
        errors: this.textMatchErrors(),
        notifyScreenreader: this.props.notifyScreenreader,
        scoringDataForBlank: this.props.blankScoringData,
        updateScoringDataForBlank: this.props.updateBlankScoringData
      });
    }
  }, {
    key: "textMatchErrors",
    value: function textMatchErrors() {
      switch (this.props.blankScoringAlgorithm) {
        case 'TextInChoices':
          return this.props.scoringDataErrors.value || {};

        case 'TextRegex':
          return this.props.scoringDataErrors.$errors || [];

        case 'TextCloseEnough':
          return this.props.scoringDataErrors.editDistance || [];

        default:
          return [];
      }
    }
  }, {
    key: "renderTextMatchOptions",
    value: function renderTextMatchOptions() {
      switch (this.props.blankScoringAlgorithm) {
        case 'TextInChoices':
          return this.renderTextMatch(_SpecifiedAnswers.default);

        case 'TextRegex':
          return this.renderTextMatch(_RegexComponent.default);

        case 'TextCloseEnough':
          return this.renderTextMatch(_EditDistance.default);

        default:
      }
    }
  }, {
    key: "renderOpenEntryOptions",
    value: function renderOpenEntryOptions() {
      var blankText = this.props.blankScoringData.blankText;
      var options = [{
        value: 'TextContainsAnswer',
        text: (0, _formatMessage.default)('Contains "{blankText}"', {
          blankText: blankText
        })
      }, {
        value: 'TextCloseEnough',
        text: (0, _formatMessage.default)('Close Enough')
      }, {
        value: 'TextEquivalence',
        text: (0, _formatMessage.default)('Exact Match')
      }, {
        value: 'TextInChoices',
        text: (0, _formatMessage.default)('Specify Correct Answers')
      }, {
        value: 'TextRegex',
        text: (0, _formatMessage.default)('Regular Expression Match')
      }];
      return options.map(function (option) {
        return _react.default.createElement("option", {
          key: option.value,
          value: option.value
        }, option.text);
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement("span", {
        className: styles.questionIcon,
        ref: this.handleContainerRef
      }, _react.default.createElement(_uiButtons.Button, {
        onClick: this.handleOpenModal,
        size: "small",
        theme: {
          borderRadius: '50%',
          smallPadding: 'none'
        },
        variant: "icon",
        icon: _uiIcons.IconQuestionLine
      }, _react.default.createElement(_uiA11y.ScreenReaderContent, null, (0, _formatMessage.default)('Text Match Help')))), _react.default.createElement(_uiForms.Select, {
        label: (0, _formatMessage.default)('Text Match'),
        onChange: this.props.updateBlankTextMatch,
        defaultOption: this.props.blankScoringAlgorithm
      }, this.renderOpenEntryOptions()), this.renderTextMatchOptions(), _react.default.createElement(_quizCommon.SimpleModal, {
        size: "small",
        title: (0, _formatMessage.default)('Text Match Options'),
        label: (0, _formatMessage.default)('Text Match Options'),
        isModalOpen: this.state.isModalOpen,
        onModalDismiss: this.handleCloseModal
      }, _ref));
    }
  }]);
  OpenEntry.displayName = "OpenEntry";
  return OpenEntry;
}(_react.Component), _class2.propTypes = {
  blankScoringAlgorithm: _propTypes.default.string,
  blankScoringData: _propTypes.default.object,
  notifyScreenreader: _propTypes.default.func.isRequired,
  scoringDataErrors: _propTypes.default.object,
  updateBlankScoringData: _propTypes.default.func,
  updateBlankTextMatch: _propTypes.default.func,
  validationErrorsFromApi: _propTypes.default.arrayOf(_propTypes.default.shape({
    type: _propTypes.default.string,
    text: _propTypes.default.string
  }))
}, _class2.defaultProps = {
  scoringDataErrors: {},
  blankScoringAlgorithm: void 0,
  blankScoringData: void 0,
  updateBlankScoringData: void 0,
  updateBlankTextMatch: void 0,
  validationErrorsFromApi: []
}, _temp)) || _class);
exports.default = OpenEntry;