"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _quizCommon = require("@instructure/quiz-common");

var _Result = _interopRequireDefault(require("../../numeric/Result"));

var _util = require("../common/util");

/**
---
category: Formula
---
  Formula Result component

  ```jsx_example
  function Example (props) {
    const exampleProps = {
      itemBody: 'Solve the equation \\(y = `m` \\cdot x + `b`\\) where x = `x`',
      interactionData: {
        variables: [
          { name: 'm', value: 2 },
          { name: 'b', value: 17.23456 },
          { name: 'x', value: 1000 }
        ]
      },
      scoredData: {
        value: {
          userResponse: '2017.23456',
          correctAnswer: '2017.23456',
          resultScore: 1
        }
      }
    }

    return (
      <FormulaResult {...exampleProps} {...props} />
    )
  }

  <SettingsSwitcher locales={LOCALES}>
      <Example />
  </SettingsSwitcher>
  ```
**/
var FormulaResult =
/*#__PURE__*/
function (_withI18nSupport) {
  (0, _inherits2.default)(FormulaResult, _withI18nSupport);

  function FormulaResult() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, FormulaResult);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(FormulaResult)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleResponseChange = function (e, value) {
      return _this.props.handleResponseUpdate(value);
    };

    return _this;
  }

  (0, _createClass2.default)(FormulaResult, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          itemBody = _this$props.itemBody,
          interactionData = _this$props.interactionData,
          other = (0, _objectWithoutProperties2.default)(_this$props, ["itemBody", "interactionData"]);
      var transformedBody = (0, _util.substituteVars)(itemBody, interactionData.variables, this.locale);
      return _react.default.createElement(_Result.default, Object.assign({}, other, {
        itemBody: transformedBody
      }));
    }
  }]);
  FormulaResult.displayName = "FormulaResult";
  return FormulaResult;
}((0, _quizCommon.withI18nSupport)(_react.Component));

exports.default = FormulaResult;
FormulaResult.propTypes = {
  itemBody: _propTypes.default.string.isRequired,
  disabled: _propTypes.default.bool,
  interactionData: _propTypes.default.object.isRequired,
  handleResponseUpdate: _propTypes.default.func.isRequired,
  scoredData: _propTypes.default.shape({
    value: _propTypes.default.shape({
      userResponse: _propTypes.default.string,
      correctAnswer: _propTypes.default.string,
      resultScore: _propTypes.default.number
    })
  }).isRequired,
  locale: _propTypes.default.string
};
FormulaResult.defaultProps = {
  locale: null
};
FormulaResult.contextTypes = {
  locale: _propTypes.default.string
};