"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _quizCommon = require("@instructure/quiz-common");

var _Take = _interopRequireDefault(require("../../numeric/Take"));

var _util = require("../common/util");

/**
---
category: Formula
---
  Formula Take component

  ```jsx_example
  function Example (props) {
    const exampleProps = {
      itemBody: 'Solve the equation \\(y = `m` \\cdot x + `b`\\) where x = `x`',
      interactionData: {
        variables: [{
          name: 'm',
          value: 2
        }, {
          name: 'b',
          value: 17.23456
        }, {
          name: 'x',
          value: 1000
        }]
      }
    }

    return (
      <FormulaTake {...exampleProps} {...props} />
    )
  }

  <SettingsSwitcher locales={LOCALES}>
    <TakeStateProvider>
      <Example />
    </TakeStateProvider>
  </SettingsSwitcher>
  ```
**/
var FormulaTake =
/*#__PURE__*/
function (_withI18nSupport) {
  (0, _inherits2.default)(FormulaTake, _withI18nSupport);

  function FormulaTake() {
    (0, _classCallCheck2.default)(this, FormulaTake);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(FormulaTake).apply(this, arguments));
  }

  (0, _createClass2.default)(FormulaTake, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          itemBody = _this$props.itemBody,
          interactionData = _this$props.interactionData,
          props = (0, _objectWithoutProperties2.default)(_this$props, ["itemBody", "interactionData"]);
      var transformedBody = (0, _util.substituteVars)(itemBody, interactionData.variables, this.locale);
      return _react.default.createElement(_Take.default, Object.assign({}, props, {
        itemBody: transformedBody
      }));
    }
  }]);
  FormulaTake.displayName = "FormulaTake";
  return FormulaTake;
}((0, _quizCommon.withI18nSupport)(_react.Component));

exports.default = FormulaTake;
FormulaTake.propTypes = {
  itemBody: _propTypes.default.string.isRequired,
  interactionData: _propTypes.default.object.isRequired,
  handleResponseUpdate: _propTypes.default.func.isRequired,
  locale: _propTypes.default.string
};
FormulaTake.defaultProps = {
  locale: null
};
FormulaTake.contextTypes = {
  locale: _propTypes.default.string
};