"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _uiThemeable = require("@instructure/ui-themeable");

var _Footer = _interopRequireDefault(require("../../../common/edit/components/Footer"));

var _MatchEdit = _interopRequireDefault(require("../MatchEdit"));

var _theme = _interopRequireDefault(require("./theme"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'cjePi',
  template: function template(theme) {
    return "\n\n.cjePi_cMRn{border-bottom:".concat(theme.matchesBorder || 'inherit', " ").concat(theme.matchesColor || 'inherit', " solid;display:block;padding-bottom:").concat(theme.matchesPadding || 'inherit', "}\n\n.cjePi_jKjZ{font-size:").concat(theme.answerButtonTextSize || 'inherit', ";padding:").concat(theme.answerButtonTextPadding || 'inherit', "}");
  },
  'matches': 'cjePi_cMRn',
  'addAnswerButtonText': 'cjePi_jKjZ'
};
var MatchListEdit = (_dec = (0, _uiThemeable.themeable)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MatchListEdit, _Component);

  function MatchListEdit() {
    (0, _classCallCheck2.default)(this, MatchListEdit);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MatchListEdit).apply(this, arguments));
  }

  (0, _createClass2.default)(MatchListEdit, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          answerErrors = _this$props.answerErrors,
          editAnswer = _this$props.editAnswer,
          editQuestion = _this$props.editQuestion,
          matches = _this$props.matches,
          questionErrors = _this$props.questionErrors;
      return _react.default.createElement("div", {
        className: styles.matches
      }, matches.map(function (match, idx) {
        return _react.default.createElement(_MatchEdit.default, {
          answerErrors: answerErrors(idx),
          editAnswer: editAnswer,
          editQuestion: editQuestion,
          disabled: _this.props.disabled,
          hasOnlyOneMatch: matches.length === 1,
          key: match.questionId,
          questionId: match.questionId,
          questionBody: match.questionBody,
          answerBody: match.answerBody,
          questionErrors: questionErrors(idx),
          removeMatch: _this.props.removeMatch,
          index: idx
        });
      }), !this.props.disabled ? _react.default.createElement(_Footer.default, {
        onCreateChoice: this.props.createNewMatch,
        buttonText: (0, _formatMessage.default)('Question/Answer Pair'),
        screenReaderText: (0, _formatMessage.default)('Add Question/Answer Pair'),
        "data-automation": "sdk-matching-add"
      }) : null);
    }
  }]);
  MatchListEdit.displayName = "MatchListEdit";
  return MatchListEdit;
}(_react.Component), _class2.propTypes = {
  answerErrors: _propTypes.default.func.isRequired,
  createNewMatch: _propTypes.default.func.isRequired,
  disabled: _propTypes.default.bool,
  editAnswer: _propTypes.default.func.isRequired,
  editQuestion: _propTypes.default.func.isRequired,
  matches: _propTypes.default.arrayOf(_propTypes.default.shape({
    questionId: _propTypes.default.string,
    questionBody: _propTypes.default.string,
    answerBody: _propTypes.default.string
  })).isRequired,
  questionErrors: _propTypes.default.func.isRequired,
  removeMatch: _propTypes.default.func.isRequired
}, _class2.defaultProps = {
  disabled: false
}, _temp)) || _class);
exports.default = MatchListEdit;