"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Match = _interopRequireDefault(require("../common/Match"));

/**
---
category: Matching
---
  Matching Take component

   ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <TakeStateProvider>
      <MatchingTake
        itemBody="Match the Presidential term with the corresponding President."
        interactionData={{
          questions: [
            { id: 'quuid1', itemBody: '1st President' },
            { id: 'quuid2', itemBody: '16th President' },
            { id: 'quuid3', itemBody: '44th President' }
          ],
          answers: ['George Washington', 'Thomas Jefferson', 'Abraham Lincoln', 'Barack Obama']
        }}
        userResponse={{
          value: { quuid1: 'George Washington' }
        }}
      />
    </TakeStateProvider>
  </SettingsSwitcher>
  ```
**/
var MatchingTake =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MatchingTake, _Component);

  function MatchingTake() {
    (0, _classCallCheck2.default)(this, MatchingTake);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MatchingTake).apply(this, arguments));
  }

  (0, _createClass2.default)(MatchingTake, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_Match.default, Object.assign({}, this.props, {
        selectedAnswers: this.props.userResponse
      }));
    }
  }]);
  MatchingTake.displayName = "MatchingTake";
  return MatchingTake;
}(_react.Component);

exports.default = MatchingTake;
MatchingTake.propTypes = {
  handleResponseUpdate: _propTypes.default.func.isRequired,
  interactionData: _Match.default.propTypes.interactionData,
  itemBody: _propTypes.default.string.isRequired,
  userResponse: _Match.default.propTypes.selectedAnswers
};
MatchingTake.defaultProps = {
  interactionData: void 0,
  userResponse: void 0
};