"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var generateAnswers = function generateAnswers(n) {
  var answers = [];

  for (var i = 0; i < n; i++) {
    answers.push({
      id: "answer-".concat(i),
      position: i + 1,
      itemBody: "<i>Answer ".concat(i, "</i>")
    });
  }

  return answers;
};

var generateScoredData = function generateScoredData(_ref) {
  var answers = _ref.answers,
      correct = _ref.correct,
      correctAnswers = _ref.correctAnswers,
      userAnswers = _ref.userAnswers;
  return {
    correct: correct,
    value: answers.reduce(function (acc, answer, index) {
      // eslint-disable-next-line no-param-reassign
      acc[answer.id] = {
        resultScore: correctAnswers && correctAnswers.includes(index) ? 1 : void 0,
        userResponded: userAnswers && userAnswers.includes(index)
      };
      return acc;
    }, {})
  };
};

var _default = {
  propValues: {
    data: [{
      correct: false,
      correctAnswers: [0, 1],
      userAnswers: [1, 2]
    }, {
      correct: true,
      correctAnswers: [0, 1],
      userAnswers: [0, 1]
    }, {
      correct: false,
      correctAnswers: [1, 2],
      userAnswers: []
    }, {
      correct: true,
      correctAnswers: [],
      userAnswers: [1, 2]
    }, {
      correctAnswers: [],
      userAnswers: []
    }, {
      correctAnswers: [0, 1]
    }, {
      correct: true
    }, {
      correct: false
    }, {
      userAnswers: []
    }, {}, null]
  },
  getComponentProps: function getComponentProps(props) {
    var answers = generateAnswers(4);
    var data = props.data;
    return {
      itemBody: data ? "Question (correct: ".concat(data.correct, " // answers: ").concat(data.correctAnswers, " // user answers: ").concat(data.userAnswers, ")") : 'No scoring data',
      scoredData: data ? generateScoredData(_objectSpread({
        answers: answers
      }, data)) : {
        value: null
      },
      interactionData: {
        choices: answers
      }
    };
  }
};
exports.default = _default;