"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Take = _interopRequireDefault(require("../Take"));

var noop = function noop() {};
/**
---
category: MultipleAnswer
---
  Multiple Answer Show component

  ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <MultipleAnswerShow
      itemBody="Who was in the first cabinet of the USA?"
      interactionData={{
        choices: [
          { id: 'uuid1', itemBody: 'Thomas Jefferson', position: 1 },
          { id: 'uuid2', itemBody: 'John Marshall', position: 2 },
          { id: 'uuid3', itemBody: 'John Knox', position: 3 },
          { id: 'uuid4', itemBody: 'Alexander Hamilton', position: 4 },
          { id: 'uuid5', itemBody: 'Aaron Burr', position: 5 },
          { id: 'uuid6', itemBody: 'Ben Franklin', position: 6 }
        ]
      }}
      scoringData={{ value: ['uuid1', 'uuid3', 'uuid4'] }}
    />
  </SettingsSwitcher>
  ```
**/


var MultipleAnswerShow =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MultipleAnswerShow, _Component);

  function MultipleAnswerShow() {
    (0, _classCallCheck2.default)(this, MultipleAnswerShow);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MultipleAnswerShow).apply(this, arguments));
  }

  (0, _createClass2.default)(MultipleAnswerShow, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_Take.default, {
        interactionData: this.props.interactionData,
        itemBody: this.props.itemBody,
        itemId: this.props.itemId,
        handleResponseUpdate: noop,
        userResponse: {
          value: this.props.scoringData.value
        },
        readOnly: true
      });
    }
  }]);
  MultipleAnswerShow.displayName = "MultipleAnswerShow";
  return MultipleAnswerShow;
}(_react.Component);

exports.default = MultipleAnswerShow;
MultipleAnswerShow.propTypes = {
  itemBody: _propTypes.default.string,
  itemId: _propTypes.default.string,
  interactionData: _Take.default.propTypes.interactionData,
  scoringData: _Take.default.propTypes.userResponse
};
MultipleAnswerShow.defaultProps = {
  itemBody: void 0,
  itemId: void 0,
  interactionData: void 0,
  scoringData: void 0
};