"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Take = _interopRequireDefault(require("../Take"));

/**
---
category: MultipleChoice
---
  Multiple Choice Show component

  ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <MultipleChoiceShow
      itemId="mc_type"
      itemBody="Who was the first President of the United States?"
      interactionData={{
        choices: [
          { id: 'uuid1', itemBody: 'George Washington', position: 1 },
          { id: 'uuid2', itemBody: 'Alexander Hamilton.', position: 2 },
          { id: 'uuid3', itemBody: 'John Adams', position: 3 },
          { id: 'uuid4', itemBody: 'Thomas Jefferson', position: 4 }
        ]
      }}
      scoringData={{ value: 'uuid1' }}
    />
  </SettingsSwitcher>
  ```
**/
var MultipleChoiceShow =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MultipleChoiceShow, _Component);

  function MultipleChoiceShow() {
    (0, _classCallCheck2.default)(this, MultipleChoiceShow);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(MultipleChoiceShow).apply(this, arguments));
  }

  (0, _createClass2.default)(MultipleChoiceShow, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_Take.default, {
        interactionData: this.props.interactionData,
        itemBody: this.props.itemBody,
        itemId: this.props.itemId,
        userResponse: {
          value: this.props.scoringData.value
        },
        readOnly: true
      });
    }
  }]);
  MultipleChoiceShow.displayName = "MultipleChoiceShow";
  return MultipleChoiceShow;
}(_react.Component);

exports.default = MultipleChoiceShow;
MultipleChoiceShow.propTypes = {
  itemBody: _propTypes.default.string.isRequired,
  itemId: _propTypes.default.string.isRequired,
  interactionData: _Take.default.propTypes.interactionData,
  scoringData: _Take.default.propTypes.userResponse
};
MultipleChoiceShow.defaultProps = {
  interactionData: void 0,
  scoringData: void 0
};