"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _uiElements = require("@instructure/ui-elements");

var _uiThemeable = require("@instructure/ui-themeable");

var _Edit = _interopRequireDefault(require("../Edit"));

var _Show = _interopRequireDefault(require("../Show"));

var _Take = _interopRequireDefault(require("../Take"));

var _Result = _interopRequireDefault(require("../Result"));

var _defaultTheme = _interopRequireDefault(require("../../common/example/defaultTheme"));

var _dec, _class, _class2, _temp;

var styles = {
  componentId: 'fEqyF',
  template: function template(theme) {
    return "\n\n.egxol_dXOl{flex:1;padding:".concat(theme.panelPadding || 'inherit', "}\n\n.egxol_qOas{display:flex}");
  },
  'panel': 'egxol_dXOl',
  'row': 'egxol_qOas'
};

var _ref =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Edit");

var _ref2 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Show");

var _ref3 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Take");

var _ref4 =
/*#__PURE__*/
_react.default.createElement(_uiElements.Heading, {
  level: "h2"
}, "Result");

var OrderingExample = (
/**
---
category: Ordering
---
  Ordering Example.

  ```jsx_example
    const WrappedExample = DragDropContext(HTML5Backend)(OrderingExample);

    <SettingsSwitcher locales={LOCALES}>
      <WrappedExample />
    </SettingsSwitcher>
  ```
**/
_dec = (0, _uiThemeable.themeable)(_defaultTheme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(OrderingExample, _Component);

  function OrderingExample(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OrderingExample);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(OrderingExample).call(this));

    _this.handleChangeItemState = function (itemState) {
      var newState = {};

      if (itemState.scoringData) {
        newState.scoredData = _this.transformScoredData(itemState.scoringData);
        newState.userResponse = _this.transformScoredData(itemState.scoringData);
      }

      if (itemState.interactionData) {
        newState.takeInteractionData = _this.transformTakeInteractionData(itemState.interactionData);
      }

      if (itemState.properties) {
        newState.properties = itemState.properties;
      }

      var updatedState = Object.assign({}, itemState, newState);

      _this.setState(updatedState);
    };

    _this.handleResponseUpdate = function (userResponse) {
      _this.setState({
        userResponse: {
          value: userResponse,
          scoredData: _this.transformScoredData(_this.state.scoringData)
        }
      });
    };

    _this.state = {};

    if (props.useDefaultData) {
      Object.assign(_this.state, {
        itemBody: 'Order these characters from tallest to shortest:',
        interactionData: {
          choices: {
            uuid6: {
              id: 'uuid6',
              itemBody: 'Gandalf'
            },
            uuid5: {
              id: 'uuid5',
              itemBody: 'Legolas'
            },
            uuid4: {
              id: 'uuid4',
              itemBody: 'Aragorn'
            },
            uuid3: {
              id: 'uuid3',
              itemBody: 'Gimli'
            },
            uuid2: {
              id: 'uuid2',
              itemBody: 'Frodo'
            },
            uuid1: {
              id: 'uuid1',
              itemBody: 'Gollum'
            }
          }
        },
        properties: {
          displayAnswersParagraph: true,
          includeLabels: true,
          topLabel: 'Taller',
          bottomLabel: 'Shorter'
        },
        userResponse: {
          value: ['uuid5', 'uuid6', 'uuid4', 'uuid3', 'uuid2', 'uuid1']
        },
        scoringData: {
          value: ['uuid6', 'uuid5', 'uuid4', 'uuid3', 'uuid2', 'uuid1']
        },
        scoredData: {}
      });
      _this.state.scoredData = _this.transformScoredData(_this.state.scoringData);
      _this.state.takeInteractionData = _this.transformTakeInteractionData(_this.state.interactionData);
    }

    return _this;
  }
  /**
   * Normally, this should be calling a service
   */


  (0, _createClass2.default)(OrderingExample, [{
    key: "transformScoredData",
    value: function transformScoredData(scoringData) {
      var _this2 = this;

      return {
        correct: this.state.userResponse.value.join() === scoringData.value.join(),
        value: Object.keys(scoringData.value).map(function (currKey, i) {
          return {
            id: i,
            userResponded: _this2.state.userResponse.value[i],
            resultScore: scoringData.value[i] === _this2.state.userResponse.value[i] ? 1 : 0,
            value: scoringData.value[i]
          };
        })
      };
    }
    /**
     * Normally, this should be calling a service
     */

  }, {
    key: "transformTakeInteractionData",
    value: function transformTakeInteractionData(interactionData) {
      return (0, _lodash.cloneDeep)(interactionData);
    }
  }, {
    key: "renderEdit",
    value: function renderEdit() {
      return _react.default.createElement("div", {
        title: "edit"
      }, _ref, _react.default.createElement(_Edit.default, {
        changeItemState: this.handleChangeItemState,
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        properties: this.state.properties,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderShow",
    value: function renderShow() {
      return _react.default.createElement("div", {
        title: "show"
      }, _ref2, _react.default.createElement(_Show.default, {
        interactionData: this.state.interactionData,
        itemBody: this.state.itemBody,
        properties: this.state.properties,
        scoringData: this.state.scoringData
      }));
    }
  }, {
    key: "renderTake",
    value: function renderTake() {
      return _react.default.createElement("div", {
        title: "take"
      }, _ref3, _react.default.createElement(_Take.default, {
        interactionData: this.state.takeInteractionData,
        itemBody: this.state.itemBody,
        userResponse: this.state.userResponse,
        properties: this.state.properties,
        handleResponseUpdate: this.handleResponseUpdate
      }));
    }
  }, {
    key: "renderResult",
    value: function renderResult() {
      return _react.default.createElement("div", {
        title: "result"
      }, _ref4, _react.default.createElement(_Result.default, {
        interactionData: this.state.takeInteractionData,
        itemBody: this.state.itemBody,
        userResponse: this.state.userResponse,
        properties: this.state.properties,
        scoredData: this.state.scoredData
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", null, _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderEdit()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderShow())), _react.default.createElement("div", {
        className: styles.row
      }, _react.default.createElement("div", {
        className: styles.panel
      }, this.renderTake()), _react.default.createElement("div", {
        className: styles.panel
      }, this.renderResult())));
    }
  }]);
  OrderingExample.displayName = "OrderingExample";
  return OrderingExample;
}(_react.Component), _class2.propTypes = {
  useDefaultData: _propTypes.default.bool
}, _class2.defaultProps = {
  useDefaultData: true
}, _temp)) || _class);
exports.default = OrderingExample;