"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _quizRce = require("@instructure/quiz-rce");

var _OrderGroup = _interopRequireDefault(require("../common/OrderGroup"));

/**
---
category: Ordering
---
  Ordering Show component

  ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <OrderingShow
      itemBody="Order these characters from tallest to shortest:"
      interactionData={{
        choices: {
          uuid6: { id: 'uuid6', itemBody: 'Gandalf' },
          uuid5: { id: 'uuid5', itemBody: 'Legolas' },
          uuid4: { id: 'uuid4', itemBody: 'Aragorn' },
          uuid3: { id: 'uuid3', itemBody: 'Gimli' },
          uuid2: { id: 'uuid2', itemBody: 'Frodo' },
          uuid1: { id: 'uuid1', itemBody: 'Gollum' }
        }
      }}
      properties={{
        displayAnswersParagraph: false,
        includeLabels: true,
        topLabel: 'Taller',
        bottomLabel: 'Shorter'
      }}
      scoringData={{
        value: ['uuid6','uuid5','uuid4','uuid3','uuid2','uuid1']
      }}
    />
  </SettingsSwitcher>
  ```
**/
var OrderingShow =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(OrderingShow, _Component);

  function OrderingShow() {
    (0, _classCallCheck2.default)(this, OrderingShow);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(OrderingShow).apply(this, arguments));
  }

  (0, _createClass2.default)(OrderingShow, [{
    key: "render",
    value: function render() {
      return _react.default.createElement(_quizRce.ItemBodyWrapper, {
        itemBody: this.props.itemBody
      }, _react.default.createElement(_OrderGroup.default, {
        bottomLabel: this.props.properties.bottomLabel,
        choiceOrder: this.props.scoringData.value,
        choices: this.props.interactionData.choices,
        displayAnswersParagraph: this.props.properties.displayAnswersParagraph,
        includeLabels: this.props.properties.includeLabels,
        topLabel: this.props.properties.topLabel,
        readOnly: true
      }));
    }
  }]);
  OrderingShow.displayName = "OrderingShow";
  return OrderingShow;
}(_react.Component);

exports.default = OrderingShow;
OrderingShow.propTypes = {
  itemBody: _propTypes.default.string.isRequired,
  interactionData: _propTypes.default.shape({
    choices: _propTypes.default.objectOf(_propTypes.default.shape({
      id: _propTypes.default.string.isRequired,
      itemBody: _propTypes.default.string.isRequired
    })).isRequired
  }).isRequired,
  scoringData: _propTypes.default.shape({
    value: _propTypes.default.arrayOf(_propTypes.default.string).isRequired
  }).isRequired,
  properties: _propTypes.default.shape({
    displayAnswersParagraph: _propTypes.default.bool,
    includeLabels: _propTypes.default.bool,
    topLabel: _propTypes.default.string,
    bottomLabel: _propTypes.default.string
  }).isRequired
};