"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _quizRce = require("@instructure/quiz-rce");

var _ChoiceBody = _interopRequireDefault(require("../components/ChoiceBody"));

/**
---
category: TrueFalse
---
  True False Show component

  ```jsx_example
  <SettingsSwitcher locales={LOCALES}>
    <TrueFalseShow
      itemBody="The sun is a star"
      itemId="12"
      interactionData={{ trueChoice: 'True', falseChoice: 'False' }}
      scoringData={{ value: false }}
    />
  </SettingsSwitcher>
  ```
**/
var TrueFalseShow =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(TrueFalseShow, _Component);

  function TrueFalseShow() {
    (0, _classCallCheck2.default)(this, TrueFalseShow);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TrueFalseShow).apply(this, arguments));
  }

  (0, _createClass2.default)(TrueFalseShow, [{
    key: "render",
    value: function render() {
      var _this$props$interacti = this.props.interactionData,
          falseChoice = _this$props$interacti.falseChoice,
          trueChoice = _this$props$interacti.trueChoice;
      return _react.default.createElement(_quizRce.ItemBodyWrapper, {
        itemBody: this.props.itemBody
      }, _react.default.createElement(_ChoiceBody.default, {
        selectedValue: this.props.scoringData.value ? 'trueChoice' : 'falseChoice',
        name: "".concat(this.props.itemId, "_show") // eslint-disable-line react/jsx-no-literals
        ,
        falseChoiceLabel: falseChoice,
        trueChoiceLabel: trueChoice,
        readOnly: true
      }));
    }
  }]);
  TrueFalseShow.displayName = "TrueFalseShow";
  return TrueFalseShow;
}(_react.Component);

exports.default = TrueFalseShow;
TrueFalseShow.propTypes = {
  itemBody: _propTypes.default.string.isRequired,
  itemId: _propTypes.default.string,
  interactionData: _propTypes.default.shape({
    trueChoice: _propTypes.default.string,
    falseChoice: _propTypes.default.string
  }).isRequired,
  scoringData: _propTypes.default.shape({
    value: _propTypes.default.bool
  }).isRequired
};
TrueFalseShow.defaultProps = {
  itemId: void 0
};