"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _react = _interopRequireDefault(require("react"));

var _sanitizeHtml = _interopRequireDefault(require("sanitize-html"));

var _instructureValidations = require("instructure-validations");

var _uiElements = require("@instructure/ui-elements");

var _quizRce = require("@instructure/quiz-rce");

var _InteractionType2 = _interopRequireDefault(require("../InteractionType"));

var _interaction_slugs = require("../../interaction_slugs");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var allowedTags = _sanitizeHtml.default.defaults.allowedTags.concat(['u', 'abbr', 'cite', 'dd', 'dfn', 'dl', 'dt', 'kbd', 'mark', 'q', 's', 'samp', 'small', 'sub', 'sup', 'time', 'var', 'address', 'article', 'aside', 'bdi', 'bdo', 'body', 'col', 'colgroup', 'data', 'del', 'figcaption', 'figure', 'footer', 'h1', 'h2', 'head', 'header', 'hgroup', 'html', 'img', 'ins', 'main', 'nav', 'rp', 'rt', 'ruby', 'section', 'span', 'style', 'summary', 'sup', 'tfoot', 'title', 'wbr']);

var EssayInteractionType =
/*#__PURE__*/
function (_InteractionType) {
  (0, _inherits2.default)(EssayInteractionType, _InteractionType);

  function EssayInteractionType(obj) {
    var _this;

    (0, _classCallCheck2.default)(this, EssayInteractionType);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(EssayInteractionType).call(this));
    _this.slug = _interaction_slugs.ESSAY_SLUG;
    _this.translatedName = (0, _formatMessage.default)('Essay');
    _this.isSubjective = true;

    _this.getDefaultScoringData = function (intData) {
      return {
        value: ''
      };
    };

    _this.getDefaultInteractionData = function () {
      return {
        essay: null,
        rce: true,
        spellCheck: false,
        wordCount: false,
        wordLimitEnabled: false,
        wordLimitMax: null,
        wordLimitMin: null,
        fileUpload: false
      };
    };

    _this.getRenderedResponse = function (responseValue, interactionData) {
      if (interactionData.rce) {
        return _react.default.createElement(_quizRce.RichContentRenderer, {
          content: (0, _sanitizeHtml.default)(responseValue, {
            allowedTags: allowedTags
          })
        });
      }

      return _react.default.createElement(_uiElements.Text, {
        color: "primary"
      }, responseValue);
    };

    (0, _get2.default)((0, _getPrototypeOf2.default)(EssayInteractionType.prototype), "initializeProps", (0, _assertThisInitialized2.default)(_this)).call((0, _assertThisInitialized2.default)(_this), obj);
    return _this;
  }

  return EssayInteractionType;
}(_InteractionType2.default);

exports.default = EssayInteractionType;
EssayInteractionType.validations = {
  interactionData: [(0, _instructureValidations.onSelf)((0, _instructureValidations.rule)('boundaries', {
    enableKey: 'wordLimitEnabled',
    minKey: 'wordLimitMin',
    maxKey: 'wordLimitMax',
    presenceMessage: (0, _formatMessage.default)('Both cannot be blank'),
    numberMessage: (0, _formatMessage.default)('Values must be integers'),
    rangeMessage: (0, _formatMessage.default)('min must be less than max')
  }))]
};