"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _react = _interopRequireDefault(require("react"));

var _instructureValidations = require("instructure-validations");

var _interaction_slugs = require("../../interaction_slugs");

var _InteractionType2 = _interopRequireDefault(require("../InteractionType"));

var _validationHelpers = require("../../util/validationHelpers");

var _TargetContainer = _interopRequireDefault(require("../../components/hotspot/common/TargetContainer"));

var _Target = _interopRequireDefault(require("../../components/hotspot/Take/Target"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var defaultInteractionData = {};
var defaultSoringData = {
  value: {}
};

function validateHotSpot() {
  var data = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  var scoringData = data.scoringData || {};
  var isPolygon = scoringData.value && scoringData.value.type === 'polygon';
  var minCoordinates = isPolygon ? 3 : 2;
  return {
    interactionData: {
      imageUrl: [(0, _instructureValidations.rule)('presence', {
        message: (0, _validationHelpers.presenceMessage)((0, _formatMessage.default)('Image'))
      })]
    },
    scoringData: {
      value: {
        type: [(0, _instructureValidations.rule)('presence', {
          message: (0, _formatMessage.default)('You must select a hotspot type')
        })],
        coordinates: [(0, _instructureValidations.rule)('listSize', {
          minMessage: (0, _formatMessage.default)('You must draw a hotpsot'),
          min: minCoordinates
        })]
      }
    }
  };
}

var HotSpotInteractionType =
/*#__PURE__*/
function (_InteractionType) {
  (0, _inherits2.default)(HotSpotInteractionType, _InteractionType);

  function HotSpotInteractionType(obj) {
    var _this;

    (0, _classCallCheck2.default)(this, HotSpotInteractionType);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(HotSpotInteractionType).call(this));
    _this.slug = _interaction_slugs.HOT_SPOT_SLUG;
    _this.translatedName = (0, _formatMessage.default)('Hot Spot');

    _this.getDefaultScoringData = function () {
      return defaultSoringData;
    };

    _this.getDefaultInteractionData = function () {
      return defaultInteractionData;
    };

    _this.getRenderedResponse = function (responseValue, interactionData) {
      return _react.default.createElement(_TargetContainer.default, {
        disabled: true,
        coordinates: [responseValue],
        drawingType: _Target.default,
        justifyContent: "left",
        url: interactionData.imageUrl
      });
    };

    (0, _get2.default)((0, _getPrototypeOf2.default)(HotSpotInteractionType.prototype), "initializeProps", (0, _assertThisInitialized2.default)(_this)).call((0, _assertThisInitialized2.default)(_this), obj);
    return _this;
  }

  (0, _createClass2.default)(HotSpotInteractionType, [{
    key: "getDefaultUserResponse",
    value: function getDefaultUserResponse() {
      return {
        value: {}
      };
    }
  }]);
  return HotSpotInteractionType;
}(_InteractionType2.default);

exports.default = HotSpotInteractionType;
HotSpotInteractionType.validations = validateHotSpot;