"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _react = _interopRequireDefault(require("react"));

var _compact = _interopRequireDefault(require("lodash/compact"));

var _uuid = require("uuid");

var _instructureValidations = require("instructure-validations");

var _quizRce = require("@instructure/quiz-rce");

var _interaction_slugs = require("../../interaction_slugs");

var _InteractionType2 = _interopRequireDefault(require("../InteractionType"));

var _validationHelpers = require("../../util/validationHelpers");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var OrderingInteractionType =
/*#__PURE__*/
function (_InteractionType) {
  (0, _inherits2.default)(OrderingInteractionType, _InteractionType);

  function OrderingInteractionType(obj) {
    var _this;

    (0, _classCallCheck2.default)(this, OrderingInteractionType);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(OrderingInteractionType).call(this));
    _this.slug = _interaction_slugs.ORDERING_SLUG;
    _this.translatedName = (0, _formatMessage.default)('Ordering');
    _this.defaultProperties = {
      includeLabels: true,
      displayAnswersParagraph: false,
      topLabel: '',
      bottomLabel: ''
    };

    _this.getDefaultInteractionData = function () {
      var _choices;

      var choiceIdA = (0, _uuid.v4)();
      var choiceIdB = (0, _uuid.v4)();
      var choiceIdC = (0, _uuid.v4)();
      var choiceIdD = (0, _uuid.v4)();
      return {
        itemBody: '',
        choices: (_choices = {}, (0, _defineProperty2.default)(_choices, choiceIdA, {
          id: choiceIdA,
          itemBody: ''
        }), (0, _defineProperty2.default)(_choices, choiceIdB, {
          id: choiceIdB,
          itemBody: ''
        }), (0, _defineProperty2.default)(_choices, choiceIdC, {
          id: choiceIdC,
          itemBody: ''
        }), (0, _defineProperty2.default)(_choices, choiceIdD, {
          id: choiceIdD,
          itemBody: ''
        }), _choices)
      };
    };

    _this.getDefaultScoringData = function (intData) {
      return {
        value: Object.keys(intData.choices).map(function (uuid) {
          return uuid;
        })
      };
    };

    _this.getRenderedResponse = function (responseValue) {
      var interactionData = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {
        choices: {}
      };
      return (0, _compact.default)(responseValue.map(function (id) {
        var choice = interactionData.choices[id];

        if (choice !== void 0) {
          return _react.default.createElement(_quizRce.RichContentRenderer, {
            key: id,
            content: choice.itemBody
          });
        } else {
          return null;
        }
      }));
    };

    (0, _get2.default)((0, _getPrototypeOf2.default)(OrderingInteractionType.prototype), "initializeProps", (0, _assertThisInitialized2.default)(_this)).call((0, _assertThisInitialized2.default)(_this), obj);
    return _this;
  }

  (0, _createClass2.default)(OrderingInteractionType, [{
    key: "getDefaultUserResponse",
    value: function getDefaultUserResponse(intData) {
      return {
        value: intData.shuffledOrder || Object.keys(intData.choices)
      };
    }
  }]);
  return OrderingInteractionType;
}(_InteractionType2.default);

exports.default = OrderingInteractionType;
OrderingInteractionType.validations = {
  interactionData: {
    choices: [(0, _instructureValidations.each)({
      itemBody: [(0, _instructureValidations.rule)('presence', {
        message: (0, _validationHelpers.presenceMessage)((0, _formatMessage.default)('Choice'))
      })]
    }), (0, _instructureValidations.rule)('noDuplicates', {
      field: 'itemBody',
      message: (0, _validationHelpers.noDuplicatesMessage)((0, _formatMessage.default)('Choice'))
    })]
  }
};