"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _pickBy = _interopRequireDefault(require("lodash/fp/pickBy"));

var _forEach = _interopRequireDefault(require("lodash/forEach"));

var _uiForms = require("@instructure/ui-forms");

var _Alert = _interopRequireDefault(require("../Alert"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var noop = function noop() {};

var dummyImg = 'https://i.ytimg.com/vi/LgkAebhJ7iE/maxresdefault.jpg';

function clone(children, props) {
  return _react.default.cloneElement(children, (0, _pickBy.default)(function (prop) {
    return prop !== void 0;
  }, props));
}

var _ref =
/*#__PURE__*/
_react.default.createElement("br", null);

var EditStateProvider =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(EditStateProvider, _Component);

  function EditStateProvider() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, EditStateProvider);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(EditStateProvider)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      itemState: {},
      errorsAreShowing: true // storage for the currently ongoing requests

    };
    _this.uploadRequests = null;

    _this.handleUpload = function (id, callback) {
      delete _this.uploadRequests[id];
      callback(dummyImg);
    };

    _this.handleErrorsAreShowingChange = function (e) {
      _this.setState({
        errorsAreShowing: e.target.checked
      });
    };

    _this.notifyScreenreader = function (content) {
      return _this.alert.setAlert(content);
    };

    _this.changeItemState = function (stateMod) {
      _this.setState(function (state) {
        return {
          itemState: _objectSpread({}, state.itemState, {}, stateMod)
        };
      });
    };

    _this.cancelMediaUpload = function (id) {
      clearTimeout(_this.uploadRequests[id]);
      delete _this.uploadRequests[id];
    };

    _this.mediaUpload = function (file, callback) {
      if (_this.uploadRequests[file] !== void 0) {
        _this.cancelMediaUpload(file);
      }

      _this.uploadRequests[file] = setTimeout(function () {
        return _this.handleUpload(file, callback);
      }, 2000 + Math.random() * 2000);
    };

    _this.handleAlertRef = function (node) {
      _this.alert = node;
    };

    return _this;
  }

  (0, _createClass2.default)(EditStateProvider, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.uploadRequests = {};
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      (0, _forEach.default)(this.uploadRequests, clearTimeout);
    }
  }, {
    key: "render",
    value: function render() {
      console.log('Current State:', this.state.itemState); // eslint-disable-line no-console

      return _react.default.createElement("div", null, _react.default.createElement(_Alert.default, {
        ref: this.handleAlertRef
      }), clone(this.props.children, _objectSpread({}, this.state.itemState, {
        changeItemState: this.changeItemState,
        notifyScreenreader: this.notifyScreenreader,
        cancelMediaUpload: this.cancelMediaUpload,
        errorsAreShowing: this.state.errorsAreShowing,
        openImportModal: noop,
        renderImportModal: noop,
        mediaUpload: this.mediaUpload
      })), _react.default.createElement("div", null, _ref, _react.default.createElement(_uiForms.Checkbox, {
        onChange: this.handleErrorsAreShowingChange,
        checked: this.state.errorsAreShowing,
        label: (0, _formatMessage.default)('Show validation errors')
      })));
    }
  }]);
  EditStateProvider.displayName = "EditStateProvider";
  return EditStateProvider;
}(_react.Component);

exports.default = EditStateProvider;
EditStateProvider.propTypes = {
  children: _propTypes.default.node.isRequired
};